%
%
%  Total Volume for Imaris 7.3.0
%
%  Copyright Bitplane AG 2011
%
%
%  Installation:
%
%  - Copy this file into the XTensions folder in the Imaris installation directory
%  - You will find this function in the Image Processing menu
%
%    <CustomTools>
%      <Menu>
%        <Item name="Total Volume" icon="Matlab" tooltip="Computes the volume of the field">
%          <Command>MatlabXT::XTTotalVolume(%i)</Command>
%        </Item>
%      </Menu>
%    </CustomTools>
%  
%
%  Description:
%
%   This XTension batch processes images.
%
%

function XTTotalVolume(aImarisApplicationID)

if isa(aImarisApplicationID, 'Imaris.IApplicationPrxHelper')
    vImarisApplication = aImarisApplicationID;
else
    % connect to Imaris interface
    if exist('ImarisLib','class') == 0
        javaaddpath ImarisLib.jar
    end
    vImarisLib = ImarisLib;
    if ischar(aImarisApplicationID)
        aImarisApplicationID = round(str2double(aImarisApplicationID));
    end
    vImarisApplication = vImarisLib.GetApplication(aImarisApplicationID);
end

vDataSet = vImarisApplication.GetDataSet;
%vSize = [vDataSet.GetSizeX,vDataSet.GetSizeY,vDataSet.GetSizeZ];
vEMax = [vDataSet.GetExtendMaxX,vDataSet.GetExtendMaxY,vDataSet.GetExtendMaxZ];
vEMin = [vDataSet.GetExtendMinX,vDataSet.GetExtendMinY,vDataSet.GetExtendMinZ];
ext = vEMax - vEMin;
vol = num2str(ext(1)*ext(2)*ext(3));
uiwait(msgbox(vol,'Bounding Box Volume','modal'));
%display(ext(1)*ext(2)*ext(3));
%display(vImarisApplication.GetCurrentFileName);

end